#ifndef HEXUTILS_H_
#define HEXUTILS_H_

#include "uart0.h"
#include <stddef.h>

#ifndef bool
#define bool unsigned char
#endif
#ifndef false
#define false 0
#endif
#ifndef true
#define true !false
#endif

#define HEX_REC_START_CODE	':'

#define HEX_REC_TYPE_DATA			0
#define HEX_REC_TYPE_EOF			1
#define HEX_REC_TYPE_EXT_SEG_ADDR	2
#define HEX_REC_TYPE_EXT_LIN_ADDR	4

#define	HEX_REC_OK				0
#define HEX_REC_ILLEGAL_CHARS	-1
#define HEX_REC_BAD_CHECKSUM	-2
#define HEX_REC_NULL_PTR		-3
#define HEX_REC_INVALID_FORMAT	-4

typedef struct
{
  unsigned char rec_data[256];
  unsigned char rec_data_len;
  unsigned short rec_address;
  unsigned char rec_type;
  unsigned char rec_checksum;
  unsigned char calc_checksum;
} hexRecord;

int           ParseHexRecord( hexRecord * record, char *inputRecord,
    int inputRecordLen );
int           ConvertHexCharToInt( char c );
int           ConvertHexASCIIByteToInt( char msb, char lsb );

#endif				/* HEXUTILS_H_ */
